#!/usr/bin/env python
#--------------
#AG rev0 16.04.2020
#SISTAMARE: 
#1)capire come allineare i kwh del rg:30531 con i Wh del reg:30529 il valore in kwh e' allineato con Sunnyportal, il valore in Wh no 
#   basterebbe riuscire a leggere l'inirizzo 40210 ??
#2)check della comunicazione con registo 30217 e' affidabile?
#3)fare file config per configurare host port e id
#--------------
#AG rev1 22.04.2020
#1)OK: rWHT=30529 -->Produzione totale in Wh valore registro=1 (+1 ogni 1Wh) registro=0 (+1 ogni 2^16Wh)--> KWHT=(Wh+nxWh)/1000
  


import datetime
from sys import argv
from pymodbus.client.sync import ModbusTcpClient
from decimal import Decimal
#host = str(argv[1]) # indirizzo IP inverter '192.168.1.200'
#port = int(argv[2]) #porta TCP:  502 

host ='192.168.1.200' #IP dello slave
port =502   #porta
N=3   #Device ID


#registri modbus 
rG1V=30783  #Tensione di rete fase L1
rG1A=30977  #Corrente di rete fase L1
rG1P=30775  #Potenza attiva
rFRQ=30803  #Frequenza di rete
#rEFF=NNNN  #Value computed
rINVT=34113 #Temperatura interna
rBOOT=34109 #TEmperatura dissipatore
rWHT=30529  #Produzione totale in Wh valore registro=1 (+1 ogni 1Wh) registro=0 (+1 ogni 2^16Wh)
rI1V=30771  #Tensione DC stringa 1
rI1A=30769  #Corrente DC stringa 1
rI1P=30773  #Potenza DC stringa 1
rI2V=30959  #Tensione DC stringa 2
rI2A=30957  #Corrente DC stringa 2
rI2P=30961  #Potenza DC stringa 2
rCHK=30217	#30217 stato contattore di rete 51=chiuso 


# int(argv[1]) #registro da leggere

client = ModbusTcpClient(host, port)
client.connect()

check=round(float(client.read_holding_registers(rCHK,2,unit=N).registers[1])/1,3)
if check==51:
    check='OK'
else:
    check='NOK'

if argv[1]=="123solar":
    SDTE=datetime.datetime.now().strftime('%Y%m%d-%H:%M:%S')
    G1V=round(float(client.read_holding_registers(rG1V,2,unit=N).registers[1])/100,3)
    G1A=round(float(client.read_holding_registers(rG1A,2,unit=N).registers[1])/1000,3)
    G1P=round(float(client.read_holding_registers(rG1P,2,unit=N).registers[1]),3)
    FRQ=round(float(client.read_holding_registers(rFRQ,2,unit=N).registers[1])/100,3)
    INVT=round(float(client.read_holding_registers(rINVT,2,unit=N).registers[1]/10),2)
    BOOT=round(float(client.read_holding_registers(rBOOT,2,unit=N).registers[1])/10,2)
    nWh=round(float(client.read_holding_registers(rWHT,2,unit=N).registers[0]),3)*65536 #registro=0 (+1 ogni 2^16Wh)
    Wh=round(float(client.read_holding_registers(rWHT,2,unit=N).registers[1]),3) #registro=1 (+1 ogni 1Wh) 
    KWHT = (Wh + nWh) / 1000
    I1V=round(float(client.read_holding_registers(rI1V,2,unit=N).registers[1])/100,3)
    I1A=round(float(client.read_holding_registers(rI1A,2,unit=N).registers[1])/1000,3)
    I1P=round(float(client.read_holding_registers(rI1P,2,unit=N).registers[1]),3)
    I2V=round(float(client.read_holding_registers(rI2V,2,unit=N).registers[1])/100,3)
    I2A=round(float(client.read_holding_registers(rI2A,2,unit=N).registers[1])/1000,3)
    I2P=round(float(client.read_holding_registers(rI2P,2,unit=N).registers[1]),3)
    EFF=round(G1P/(I1P+I2P)*100,3)
    #check='OK'
    sData=str(SDTE)+" "+str(G1V)+" "+str(G1A)+" "+str(G1P)+" "+str(FRQ)+" "+str(EFF)+" "+str(INVT)+" "+str(BOOT)+" "+str(KWHT)+" "+str(I1V)+" "+str(I1A)+" "+str(I1P)+" "+str(I2V)+" "+str(I2A)+" "+str(I2P)+" "+str(check) #Lungo 16
    print sData

 
else:
    reg = round(float(client.read_holding_registers(int(argv[1]),2,unit=N).registers[1])/1,3)
    print reg
    #print trr
client.close()